VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "B-Spline Curve"
   ClientHeight    =   5445
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   6825
   Height          =   5820
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   5445
   ScaleWidth      =   6825
   Top             =   1110
   Width           =   6945
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   5415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6735
      _Version        =   131072
      _ExtentX        =   11880
      _ExtentY        =   9551
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Initialize()
    
    Dim root As SoSeparator
    Set root = New SoSeparator

    'Create the scene graph for the spiral
    Dim spiral As SoSeparator
    Set spiral = New SoSeparator
    Dim curveSep As SoSeparator
    Set curveSep = makeCurve()
    Dim lmodel As SoLightModel
    Set lmodel = New SoLightModel
    Dim clr As SoBaseColor
    Set clr = New SoBaseColor

    Call lmodel.model.setValue(0)   'SoLightModel::BASE_COLOR;
    Call clr.RGB.setValue(1#, 0#, 0.1)
    Call spiral.addChild(lmodel)
    Call spiral.addChild(clr)
    Call spiral.addChild(curveSep)
    Call root.addChild(spiral)

    'Create the scene graph for the floor
    Dim floor As SoSeparator
    Set floor = New SoSeparator
    Dim xlate As SoTranslation
    Set xlate = New SoTranslation
    Dim rot   As SoRotation
    Set rot = New SoRotation
    Dim scale1 As SoScale
    Set scale1 = New SoScale
    Dim myInput As SoInput
    Set myInput = New SoInput
    Dim result As SoGroup
    
    Set idisp = V3Space1.GetIDispatch
    Set result = myInput.readAllUrl("examples\data\floorData.iv", idisp)

    Call xlate.translation.setValue(-12#, -5#, -5#)
    Call scale1.scaleFactor.setValue(2#, 1#, 2#)
    
    Set vec3f = New SbVec3f
    Call vec3f.setValue(0#, 1#, 0#)
    
    Dim tRot As SbRotation
    Set tRot = New SbRotation
    Call tRot.setValue(vec3f, 3.14159265358979 / 2#)
    
    Call rot.rotation.setValue(tRot)
    Call floor.addChild(rot)
    Call floor.addChild(xlate)
    Call floor.addChild(scale1)
    Call floor.addChild(result)
    Call root.addChild(floor)

    'Create the scene graph for the spiral's shadow
    Dim shadow As SoSeparator
    Set shadow = New SoSeparator
    Dim shmdl  As SoLightModel
    Set shmdl = New SoLightModel
    Dim shmtl  As SoMaterial
    Set shmtl = New SoMaterial
    Dim shclr  As SoBaseColor
    Set shclr = New SoBaseColor
    Dim shxl As SoTranslation
    Set shxl = New SoTranslation
    Dim shscl  As SoScale
    Set shscl = New SoScale
   
    Call shmdl.model.setValue(0)    'SoLightModel::BASE_COLOR;
    Call shclr.RGB.setValue(0.21, 0.15, 0.09)
    Call shmtl.transparency.setValue(0.5)
    Call shxl.translation.setValue(0#, -4.9, 0#)
    Call shscl.scaleFactor.setValue(1#, 0#, 1#)
    Call shadow.addChild(shmtl)
    Call shadow.addChild(shmdl)
    Call shadow.addChild(shclr)
    Call shadow.addChild(shxl)
    Call shadow.addChild(shscl)
    Call shadow.addChild(curveSep)
    Call root.addChild(shadow)

    Call V3Space1.setSceneRoot(root)
   
    Dim cam As Object
    Set cam = V3Space1.getCurrentCamera
    Call cam.position.setValue(-6#, 8#, 20#)
    
    Call vec3f.setValue(0#, -2#, -4#)
    Call cam.pointAt(vec3f)

    Set root = Nothing
    Set spiral = Nothing
    Set curveSep = Nothing
    Set lmodel = Nothing
    Set clr = Nothing
    Set floor = Nothing
    Set xlate = Nothing
    Set rot = Nothing
    Set scale1 = Nothing
    Set myInput = Nothing
    Set result = Nothing
    Set idisp = Nothing
    Set vec3f = Nothing
    Set tRot = Nothing
    Set shadow = Nothing
    Set shmdl = Nothing
    Set shmtl = Nothing
    Set shclr = Nothing
    Set shxl = Nothing
    Set shscl = Nothing
    Set cam = Nothing
    
End Sub

Public Function makeCurve() As SoSeparator
    Dim curveSep As SoSeparator
    Set curveSep = New SoSeparator

    'Set the draw style of the curve.
    Dim drawStyle  As SoDrawStyle
    Set drawStyle = New SoDrawStyle
    Call drawStyle.lineWidth.setValue(4)
    Call curveSep.addChild(drawStyle)

    'Define the NURBS curve including the control points
    'and a complexity.
    Dim complexity As SoComplexity
    Set complexity = New SoComplexity
    Dim controlPts As SoCoordinate3
    Set controlPts = New SoCoordinate3
    Dim curve As SoNurbsCurve
    Set curve = New SoNurbsCurve
    
    Call complexity.Value.setValue(0.8)
    '0   { 6.0,  0.0,  6.0},
    Call controlPts.Point.set1Value(0, 6#, 0#, 6#)
    '1   {-5.5,  0.5,  5.5},
    Call controlPts.Point.set1Value(1, -5.5, 0.5, 5.5)
    '2   {-5.0,  1.0, -5.0},
    Call controlPts.Point.set1Value(2, -5#, 1#, -5#)
    '3   { 4.5,  1.5, -4.5},
    Call controlPts.Point.set1Value(3, 4.5, 1.5, -4.5)
    '4   { 4.0,  2.0,  4.0},
    Call controlPts.Point.set1Value(4, 4#, 2#, 4#)
    '5   {-3.5,  2.5,  3.5},
    Call controlPts.Point.set1Value(5, -3.5, 2.5, 3.5)
    '6   {-3.0,  3.0, -3.0},
    Call controlPts.Point.set1Value(6, -3#, 3#, -3#)
    '7   { 2.5,  3.5, -2.5},
    Call controlPts.Point.set1Value(7, 2.5, 3.5, -2.5)
    '8   { 2.0,  4.0,  2.0},
    Call controlPts.Point.set1Value(8, 2#, 4#, 2#)
    '9   {-1.5,  4.5,  1.5},
    Call controlPts.Point.set1Value(9, -1.5, 4.5, 1.5)
    '10   {-1.0,  5.0, -1.0},
    Call controlPts.Point.set1Value(10, -1#, 5#, -1#)
    '11   { 0.5,  5.5, -0.5},
    Call controlPts.Point.set1Value(11, 0.5, 5.5, -0.5)
    '12   { 0.0,  6.0,  0.0}};
    Call controlPts.Point.set1Value(12, 0#, 6#, 0#)

    curve.numControlPoints.setValue (13)
    
    'The knot vector
    '0, 0, 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10};
    Call curve.knotVector.set1Value(0, 0)
    Call curve.knotVector.set1Value(1, 0)
    Call curve.knotVector.set1Value(2, 0)
    Call curve.knotVector.set1Value(3, 0)
    Call curve.knotVector.set1Value(4, 1)
    Call curve.knotVector.set1Value(5, 2)
    Call curve.knotVector.set1Value(6, 3)
    Call curve.knotVector.set1Value(7, 4)
    Call curve.knotVector.set1Value(8, 5)
    Call curve.knotVector.set1Value(9, 6)
    Call curve.knotVector.set1Value(10, 7)
    Call curve.knotVector.set1Value(11, 8)
    Call curve.knotVector.set1Value(12, 9)
    Call curve.knotVector.set1Value(13, 10)
    Call curve.knotVector.set1Value(14, 10)
    Call curve.knotVector.set1Value(15, 10)
    Call curve.knotVector.set1Value(16, 10)
    
    Call curveSep.addChild(complexity)
    Call curveSep.addChild(controlPts)
    Call curveSep.addChild(curve)

    Set makeCurve = curveSep
    
    Set curceSep = Nothing
    Set drawStyle = Nothing
    Set complexity = Nothing
    Set controlPts = Nothing
    Set curve = Nothing
    
End Function
